;;HACK
(define-syntax-rule (define-module- name args ...)
  (cond-expand
   (guile-3
    (define-module name
      #:declarative? #f
      args ...))
   (guile
    (define-module name args ...))))


(define-module- (logic guile-log guile-prolog vm-compiler2)
  #:use-module (logic guile-log)
  #:use-module (ice-9 pretty-print)
  #:use-module (logic guile-log iso-prolog)
  #:use-module (logic guile-log guile-prolog hash)
  #:use-module (logic guile-log guile-prolog ops)
  #:use-module (logic guile-log prolog swi)
  #:use-module (logic guile-log vlist)
  #:use-module (logic guile-log match)
  #:use-module (logic guile-log guile-prolog macros)
  #:use-module (logic guile-log guile-prolog vm vm-pre)
  #:use-module (logic guile-log guile-prolog vm vm-var2)
  #:use-module (logic guile-log guile-prolog vm vm-goal2)
  #:use-module (logic guile-log prolog compile)
  #:use-module ((logic guile-log umatch) #:select (gp-var! *current-stack*))
  #:use-module (system vm assembler)
  #:re-export (compile_goal begin_att end_att cc pr extended_off extended_on)
  #:export (compilable_scm 
	    collect_data define-prolog-fkn
	    make-vm-function
	    compile_to_fkn
	    instr define-prolog
	    mockalambda))
#|
VM Compiler that runs on the VM Should be faster than the scheme compiler
currently unstable
|#

(include-from-path "logic/guile-log/guile-prolog/vm/vm-compiler.scm")
