;;HACK
(define-syntax-rule (define-module- name args ...)
  (cond-expand
   (guile-3
    (define-module name
      #:declarative? #f
      args ...))
   (guile
    (define-module name args ...))))


(define-module- (logic guile-log canonacalize)
  #:use-module (logic guile-log umatch)
  #:export (canon-it un-canon-it))

(define vals (map (lambda (x) 
		    (gensym (format #f "CANON-~a-" x)))
		  (iota 100)))
(define valn      (gensym "CANON-N-"))
(define valf      (gensym "CANON-F-"))
(define nothing (lambda (a b c) #f))
(define (id a b x s) x)
(define (canon-it+ x s) (canon-it++ gp->scm nothing x s))
(define *canon-it* (make-fluid canon-it+))
(define (canon-it x s) ((fluid-ref *canon-it*) x s))
(define recurs-maps (make-fluid #f))
(define (canon-it++ gp->scm analyze x s)
  (define vs vals)
  (define tr  (make-hash-table))
  (define mp  (make-hash-table))
  (define n  0)
  (define nn 0)
  (call-with-values (lambda () (gp->scm x s))
    (lambda (x)
      (analyze mp x s)
      (let lp ((x x) (first #t))
	(cond	 
	 ((and first (hashq-ref mp x))
	  (if (hash-ref tr x)
	      (hash-ref tr x)
	      (let ((i nn))
		(set! nn (+ nn 1))
		(hash-set! tr x (cons valf i))
		(cons* valf i (lp x #f)))))
	 	 
	 ((pair? x)
	  (cons (lp (car x) #t) (lp (cdr x) #t)))

	 ((vector? x)
	  (list->vector
	   (lp (vector->list x) #t)))

	 ((gp-var? x s)
	  (let ((r (hash-ref tr x)))
	    (if r
		r
		(if (pair? vs)
		    (let ((tag (car vs)))
		      (set! vs (cdr vs))
		      (hash-set! tr x tag)
		      tag)
		    (let ((tag (cons valn n)))
		      (set! n (+ n 1))
		      (hash-set! tr x tag)
		      tag)))))

	 ((variable? x) 
	  (lp (variable-ref x) #t))

	 (else
	  x))))))

(define (un-canon-it x)
  (define vs vals)
  (define n  0)
  (define tr (make-hash-table))
  (let lp ((x x))
    (cond
     ((pair? x)
      (if (and (pair? vs) (not (eq? (car x) valf)))
	  (cons (lp (car x)) (lp (cdr x)))
	  (let ((ca (car x))
		(cd (cdr x)))
	    (cond
	     ((eq? ca valf)
	      (if (pair? cd)
		  (let ((tag (cons valf (car cd)))
			(var (make-variable #f)))
		    (hash-set! tr tag var)
		    (variable-set! var (lp (cdr cd)))
		    var)
		  (hash-ref tr x 'error-in-cyclic-uncanon)))
	     ((eq? ca valn)
	      (if (= cd n)
		  (let ((untag (gp-make-var)))
		    (hash-set! tr x untag)
		    (set! n (+ n 1))
		    untag)
		  (hash-ref tr x)))
	     (else
	      (cons (lp ca) (lp cd)))))))
     ((vector? x)
      (list->vector (lp (vector->list x))))
     (else
      (if (symbol? x)
	  (let ((r (hash-ref tr x)))
	    (if r
		r
		(if (eq? x (car vs))
		    (let ((untag (gp-make-var)))
		      (set! vs (cdr vs))
		      (hash-set! tr x untag)
		      untag)
		    x)))
	  x)))))
		      
